Vue Bootstrap Grid Usage

Vue Grid usage - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Use the powerful mobile-first flexbox grid to build layouts of all shapes and sizes thanks to a twelve column system, five default responsive tiers, Sass variables and mixins, and dozens of predefined classes.


How it works

Bootstrap’s grid system uses a series of containers, rows, and columns to layout and align content. It’s built with flexbox and is fully responsive. Below is an example and an in-depth look at how the grid comes together.

New to or unfamiliar with flexbox? Read our CSS flexbox guide.

One of three columns
One of three columns
One of three columns
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col col="sm">One of three columns</mdb-col>
              <mdb-col col="sm">One of three columns</mdb-col>
              <mdb-col col="sm">One of three columns</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

The above example creates three equal-width columns on small, medium, large, and extra large devices using our predefined grid classes. Those columns are centered in the page with the parent mdb-container.

Breaking it down, here’s how it works:

  • Containers provide a means to center your site’s contents. Use mdb-ontainer for fixed width or mdb-container with fluid prop for width: 100% across all viewport and device sizes.
  • Rows are wrappers for columns. Each column has horizontal padding (called a gutter) for controlling the space between them. This padding is then counteracted on the rows with negative margins. This way, all the content in your columns is visually aligned down the left side.
  • In a grid layout, content must be placed within columns and only columns may be immediate children of rows.
  • Thanks to flexbox, grid columns without a specified width will automatically layout as equal width columns. For example, four instances of sm="4" will each automatically be 25% wide from the small breakpoint and up. See the auto-layout columns section for more examples.
  • Column classes indicate the number of columns you’d like to use out of the possible 12 per row. So, if you want three equal-width columns, you can use .col-sm-4.
  • Column widths are set in percentages, so they’re always fluid and sized relative to their parent element.
  • Columns have horizontal padding to create the gutters between individual columns, however, you can remove the margin from rows and padding from columns with .no-gutters on the mdb-row.
  • To make the grid responsive, there are five grid breakpoints, one for each responsive breakpoint: all breakpoints (extra small), small, medium, large, and extra large.
  • Grid breakpoints are based on minimum width media queries, meaning they apply to that one breakpoint and all those above it (e.g., sm="4" applies to small, medium, large, and extra large devices, but not the first xs breakpoint).
  • You can use predefined grid classes (like col="4") or Sass mixins for more semantic markup.

Be aware of the limitations and bugs around flexbox, like the inability to use some HTML elements as flex containers.


Grid options

While Bootstrap uses ems or rems for defining most sizes, pxs are used for grid breakpoints and container widths. This is because the viewport width is in pixels and does not change with the font size.

See how aspects of the Bootstrap grid system work across multiple devices with a handy table.

Extra small
<576px
Small
≥576px
Medium
≥768px
Large
≥992px
Extra large
≥1200px
Grid behavior Horizontal at all times Collapsed to start, horizontal above breakpoints
Container width None (auto) 540px 720px 960px 1140px
Class prefix .col- .col-sm- .col-md- .col-lg- .col-xl-
# of columns 12
Gutter width 30px (15px on each side of a column)
Nestable Yes
Column ordering Yes

Auto-layout columns

Utilize breakpoint-specific column classes for easy column sizing without an explicit numbered prop like sm="6".

Equal-width

For example, here are two grid layouts that apply to every device and viewport, from xs to xl. Add any number of unit-less classes for each breakpoint you need and every column will be the same width.

1 of 2
1 of 2
1 of 3
1 of 3
1 of 3
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col>1 of 2</mdb-col>
              <mdb-col>2 of 2</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col>1 of 3</mdb-col>
              <mdb-col>2 of 3</mdb-col>
              <mdb-col>3 of 3</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Equal-width columns can be broken into multiple lines, but there is a Safari flexbox bug that prevents this from working without an explicit flex-basis or border. There are workarounds for older browser versions, but they shouldn’t be necessary if you’re up-to-date.

Column
Column
Column
Column
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col>Column</mdb-col>
              <mdb-col>Column</mdb-col>
              <div class="w-100"></div>
              <mdb-col>Column</mdb-col>
              <mdb-col>Column</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Setting one column width

Auto-layout for flexbox grid columns also means you can set the width of one column and have the sibling columns automatically resize around it. You may use predefined grid classes (as shown below), grid mixins, or inline widths. Note that the other columns will resize no matter the width of the center column.

1 of 3
2 of 3 (wider)
3 of 3
1 of 3
2 of 3 (wider)
3 of 3
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col>1 of 3</mdb-col>
              <mdb-col col="6">2 of 3 (wider)</mdb-col>
              <mdb-col>3 of 3</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col>1 of 3</mdb-col>
              <mdb-col col="5">2 of 3 (wider)</mdb-col>
              <mdb-col>3 of 3</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Variable width content

Using the col-{breakpoint}-auto classes, columns can size itself based on the natural width of its content. This is particularly handy when dealing with single line content (like inputs, numbers, etc.) or in conjunction horizontal alignment classes, when centering layouts with uneven column sizes as viewport width changes.

1 of 3
Variable width content
3 of 3
1 of 3
Variable width content
3 of 3
        
            
        <template>
          <mdb-container>
            <mdb-row class="justify-content-md-center">
              <mdb-col lg="2">1 of 3</mdb-col>
              <mdb-col md="auto" col="12">Variable width content</mdb-col>
              <mdb-col lg="2">3 of 3</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col>1 of 3</mdb-col>
              <mdb-col col="5">Variable width content</mdb-col>
              <mdb-col>3 of 3</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Equal-width multi-row

Create equal-width columns that span multiple rows by inserting a .w-100 where you want the columns to break to a new line. Make the breaks responsive by mixing the .w-100 with some responsive display utilities.

col
col
col
col
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col>col</mdb-col>
              <mdb-col>col</mdb-col>
              <div class="w-100"></div>
              <mdb-col>col</mdb-col>
              <mdb-col>col</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Responsive classes

Bootstrap’s grid includes five tiers of predefined classes for building complex responsive layouts. Customize the size of your columns on extra small, small, medium, large, or extra large devices however you see fit.

All breakpoints

For grids that are the same from the smallest of devices to the largest, use the col="*" props. Specify a numbered class when you need a particularly sized column; otherwise, feel free to stick to mdb-col.

col
col
col
col
col-8
col-4
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col>col</mdb-col>
              <mdb-col>col</mdb-col>
              <mdb-col>col</mdb-col>
              <mdb-col>col</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col col="8">col</mdb-col>
              <mdb-col col="4">col</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Stacked to horizontal

Using a single set of sm="*" props, you can create a basic grid system that starts out stacked before becoming horizontal on desktop (medium) devices.

col-sm-8
col-sm-4
col-sm
col-sm
col-sm
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="8">sm="8"</mdb-col>
              <mdb-col sm="4">sm="4"</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col col="sm">col="sm"</mdb-col>
              <mdb-col col="sm">col="sm"</mdb-col>
              <mdb-col col="sm">col="sm"</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Mix and match

Don’t want your columns to simply stack in some grid tiers? Use a combination of different classes for each tier as needed. See the example below for a better idea of how it all works.

.col .col-md-8
.col-6 .col-md-4
.col-6 .col-md-4
.col-6 .col-md-4
.col-6 .col-md-4
.col-6
.col-6
        
            
        <template>
          <mdb-container>
            <!-- Stack the columns on mobile by making one full-width and the other half-width -->
            <mdb-row>
              <mdb-col md="8">
                md="8"
              </mdb-col>
              <mdb-col col="6" md="4">
                col="6" md="4"
              </mdb-col>
            </mdb-row>
            <!-- Columns start at 50% wide on mobile and bump up to 33.3% wide on desktop -->
            <mdb-row>
              <mdb-col col="6" md="4">
                col="6" md="4"
              </mdb-col>
              <mdb-col col="6" md="4">
                col="6" md="4"
              </mdb-col>
              <mdb-col col="6" md="4">
                col="6" md="4"
              </mdb-col>
            </mdb-row>
            <!-- Columns are always 50% wide, on mobile and desktop -->
            <mdb-row>
              <mdb-col col="6">
                col="6"
              </mdb-col>
              <mdb-col col="6">
                col="6"
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Alignment

Use flexbox alignment utilities to vertically and horizontally align columns.

Vertical alignment

For grids that are the same from the smallest of devices to the largest, use the col="*" props. Specify a numbered class when you need a particularly sized column; otherwise, feel free to stick to mdb-col.

Align items start

One of three columns
One of three columns
One of three columns

Align items center

One of three columns
One of three columns
One of three columns

Align items end

One of three columns
One of three columns
One of three columns
        
            
        <template>
          <mdb-container>
            <mdb-row class="align-items-start">
              <mdb-col>One of three columns</mdb-col>
              <mdb-col>One of three columns</mdb-col>
              <mdb-col>One of three columns</mdb-col>
            </mdb-row>
            <mdb-row class="align-items-center">
              <mdb-col>One of three columns</mdb-col>
              <mdb-col>One of three columns</mdb-col>
              <mdb-col>One of three columns</mdb-col>
            </mdb-row>
            <mdb-row class="align-items-end">
              <mdb-col>One of three columns</mdb-col>
              <mdb-col>One of three columns</mdb-col>
              <mdb-col>One of three columns</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
      
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Algin self

Use align-self utilities on flexbox items to individually change their alignment on the cross axis (the y-axis to start, x-axis if flex-direction: column). Choose from the same options as align-items: start, end, center.

One of three columns
One of three columns
One of three columns
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col class="align-self-start">One of three columns</mdb-col>
              <mdb-col class="align-self-center">One of three columns</mdb-col>
              <mdb-col class="align-self-end">One of three columns</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Horizontal alignment

Change the alignment of flex items on the main axis. Choose from start, end, center, between, or around.

One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
        
            
        <template>
          <mdb-container>
            <mdb-row class="justify-content-start">
              <mdb-col col="4">
                One of two columns
              </mdb-col>
              <mdb-col col="4">
                One of two columns
              </mdb-col>
            </mdb-row>
            <mdb-row class="justify-content-center">
              <mdb-col col="4">
                One of two columns
              </mdb-col>
              <mdb-col col="4">
                One of two columns
              </mdb-col>
            </mdb-row>
            <mdb-row class="justify-content-end">
              <mdb-col col="4">
                One of two columns
              </mdb-col>
              <mdb-col col="4">
                One of two columns
              </mdb-col>
            </mdb-row>
            <mdb-row class="justify-content-around">
              <mdb-col col="4">
                One of two columns
              </mdb-col>
              <mdb-col col="4">
                One of two columns
              </mdb-col>
            </mdb-row>
            <mdb-row class="justify-content-between">
              <mdb-col col="4">
                One of two columns
              </mdb-col>
              <mdb-col col="4">
                One of two columns
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

No gutters

The gutters between columns in our predefined grid classes can be removed with .no-gutters. This removes the negative margins from mdb-row and the horizontal padding from all immediate children columns.

Here’s the source code for creating these styles. Note that column overrides are scoped to only the first children columns and are targeted via attribute selector. While this generates a more specific selector, column padding can still be further customized with spacing utilities.

Need an edge-to-edge design? Drop the parent mdb-container or mdb-container with fluid prop.

        
            
            .no-gutters {
              margin-right: 0;
              margin-left: 0;
            }
            >.c ol,
            > [class*="col-"] {
              padding-right: 0;
              padding-left: 0;
            }
        
        
    

In practice, here’s how it looks. Note you can continue to use this with all other predefined grid classes (including column widths, responsive tiers, reorders, and more).

.col-12 .col-sm-6 .col-md-8
.col-6 .col-md-4
        
            
        <template>
          <mdb-container>
            <mdb-row class="no-gutters">
              <mdb-col col="12" sm="6" md="8">
                col="12" sm="6" md="8"
              </mdb-col>
              <mdb-col col="6" md="4">
                col="6" md="4"
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Column wrapping

If more than 12 columns are placed within a single row, each group of extra columns will, as one unit, wrap onto a new line.

.col-9
.col-4
Since 9 + 4 = 13 > 12, this 4-column-wide div gets wrapped onto a new line as one contiguous unit.
.col-6
Subsequent columns continue along the new line.
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col col="9">col="9"</mdb-col>
              <mdb-col col="4">col="4"
                <br>Since 9 + 4 = 13 &gt; 12, this 4-column-wide div gets wrapped onto a new line as one contiguous unit.</mdb-col>
              <mdb-col col="6">col="6"
                <br>Subsequent columns continue along the new line.</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Column breaks

Breaking columns to a new line in flexbox requires a small hack: add an element with width: 100% wherever you want to wrap your columns to a new line. Normally this is accomplished with multiple .rows, but not every implementation method can account for this.

.col-6 .col-sm-4
.col-6 .col-sm-4
.col-6 .col-sm-4
.col-6 .col-sm-4
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col col="6" sm="3">
                col="6" sm="3"
              </mdb-col>
              <mdb-col col="6" sm="3">
                col="6" sm="3"
              </mdb-col>
              <!-- Force next columns to break to new line -->
              <div class="w-100"></div>
              <mdb-col col="6" sm="3">
                col="6" sm="3"
              </mdb-col>
              <mdb-col col="6" sm="3">
                col="6" sm="3"
              </mdb-col>
            </mdb-row>
         </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

With the handful of grid tiers available, you’re bound to run into issues where, at certain breakpoints, your columns don’t clear quite right as one is taller than the other. To fix that, use a combination of a .clearfix and our responsive utility classes.

.col-6 .col-sm-4
.col-6 .col-sm-4
.col-6 .col-sm-4
.col-6 .col-sm-4
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col col="6" sm="4">
                col="6" sm="4"
              </mdb-col>
              <mdb-col col="6" sm="4">
                col="6" sm="4"
              </mdb-col>
              <!-- Force next columns to break to new line at md breakpoint and up -->
              <div class="w-100 d-none d-md-block"></div>
              <mdb-col col="6" sm="4">
                col="6" sm="4"
              </mdb-col>
              <mdb-col col="6" sm="4">
                col="6" sm="4"
              </mdb-col>
            </mdb-row>
         </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Reordering

Order classes

Use .order- classes for controlling the visual order of your content. These classes are responsive, so you can set the order by breakpoint (e.g., .order-1.order-md-2). Includes support for 1 through 12 across all five grid tiers.

First, but unordered
Second, but last
Third, but second
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col>
                First, but unordered
              </mdb-col>
              <mdb-col class="order-12">
                Second, but last
              </mdb-col>
              <mdb-col class="order-1">
                Third, but second
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

There are also responsive .order-first and .order-last classes that change the order of an element by applying order: -1 and order: 13 ( order: $columns + 1), respectively. These classes can also be intermixed with the numbered .order-* classes as needed.

First, but last
Second, but unordered
Third, but first
        
            
        <mdb-container>
          <mdb-row>
            <mdb-col>
              First, but unordered
            </mdb-col>>
            <mdb-col>
              Second, but unordered
            </mdb-col>>
            <mdb-col class="order-first">
              Third, but first
            </mdb-col>>
          </mdb-row>
        </mdb-container>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Offsetting columns

You can offset grid columns in two ways: our responsive offset="*" grid props and our margin utilities. Grid classes are sized to match columns while margins are more useful for quick layouts where the width of the offset is variable.

Offset classes

Move columns to the right using offsetMd="*" props. These classes increase the left margin of a column by * columns. For example, offsetMd="4" moves mdb-col md="4" over four columns.

md="4"
md="4" offsetMd="4"
md="3" offsetMd="3"
md="3" offsetMd="3"
md="6" offsetMd="3"
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col md="4">md="4"</div>
              <mdb-col md="4" offsetMd="4">md="4" offsetMd="4"</div>
            </mdb-row>
            <mdb-row>
              <mdb-col md="3" offsetMd="3">md="3" offsetMd="3"</div>
              <mdb-col md="3" offsetMd="3">md="3" offsetMd="3"</div>
            </mdb-row>
            <mdb-row>
              <mdb-col md="6" offsetMd="3">md="6" offsetMd="3"</div>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

In addition to column clearing at responsive breakpoints, you may need to reset offsets. See this in action in the grid example.

sm="5" md="6"
sm="5" offsetSm="2" md="6" offsetMd="0"
sm="6" md="5" lg="6"
sm="6" md="5" offsetMd="2" lg="6" offsetLg="0"
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="5" md="6">sm="5" md="6"</mdb-col>
              <mdb-col sm="5" offsetSm="2" md="6" offsetMd="0">sm="5" offsetSm="2" md="6" offsetMd="0"</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col sm="6" md="5" lg="6">sm="6" md="5" lg="6"</mdb-col>
              <mdb-col sm="6" md="5" offsetMd="2" lg="6" offsetLg="0">sm="6" md="5" offsetMd="2" lg="6" offsetLg="0"</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Margin utilities

With the move to flexbox in v4, you can use margin utilities like .mr-auto to force sibling columns away from one another.

md="4"
.col-md-4 .ml-auto
md="3" .ml-md-auto
md="3" .ml-md-auto
col="auto" .mr-auto
col="auto"
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col md="4">md="4"</mdb-col>
              <mdb-col md="4" class="ml-auto">md="4" .ml-auto</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col md="3" class="ml-md-auto">md="3" .ml-md-auto</mdb-col>
              <mdb-col md="3" class="ml-md-auto">md="3" .ml-md-auto</mdb-col>
            </mdb-row>
            <mdb-row>
              <mdb-col col="auto" class="mr-auto">col="auto" .mr-auto</mdb-col>
              <mdb-col col="auto">col="auto"</mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Nesting

To nest your content with the default grid, add a new .row and set of .col-sm-* columns within an existing .col-sm-* column. Nested rows should include a set of columns that add up to 12 or fewer (it is not required that you use all 12 available columns).

Level 1: .col-sm-9
Level 2: .col-8 .col-sm-6
Level 2: .col-4 .col-sm-6
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="9">
                Level 1: sm="9"
                <mdb-row>
                  <mdb-col col="8" sm="6">
                    Level 2: col="8" sm="6"
                  </mdb-col>
                  <mdb-col col="4" sm="6">
                    Level 2: col="4" sm="6"
                  </mdb-col>
                </mdb-row>
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {mdbContainer, mdbRow, mdbCol} from 'mdbvue';
          export default {
            components: {
              mdbContainer,
              mdbRow,
              mdbCol
            }
          }
        </script>
        
        
    

Sass mixins

When using Bootstrap's source Sass files, you have the option of using Sass variables and mixins to create custom, semantic, and responsive page layouts. Our predefined grid classes use these same variables and mixins to provide a whole suite of ready-to-use classes for fast responsive layout.

Variables

Variables and maps determine the number of columns, the gutter width, and the media query point at which to begin floating columns. We use these to generate the predefined grid classes documented above, as well as for the custom mixins listed below.

        
            
              $grid-columns:      12;
              $grid-gutter-width: 30px;
  
              $grid-breakpoints: (
                // Extra small screen / phone
                xs: 0,
                // Small screen / phone
                sm: 576px,
                // Medium screen / tablet
                md: 768px,
                // Large screen / desktop
                lg: 992px,
                // Extra large screen / wide desktop
                xl: 1200px
              );
  
              $container-max-widths: (
                sm: 540px,
                md: 720px,
                lg: 960px,
                xl: 1140px
              );
          
        
    

Mixins

Mixins are used in conjunction with the grid variables to generate semantic CSS for individual grid columns.

        
            
            /* Creates a wrapper for a series of columns */
            @include make-row();

            /* Make the element grid-ready (applying everything but the width) */
            @include make-col-ready();
            @include make-col($size, $columns: $grid-columns);

            /* Get fancy by offsetting, or changing the sort order */
            @include make-col-offset($size, $columns: $grid-columns);
          
        
    

Example usage

You can modify the variables to your own custom values, or just use the mixins with their default values. Here’s an example of using the default settings to create a two-column layout with a gap between.

Main content
Secondary content
        
            
        <template>
          <div class="example-container">
            <div class="example-row">
              <div class="example-content-main">Main content</div>
              <div class="example-content-secondary">Secondary content</div>
            </div>
          </div>
        </template>
        
        
    
        
            
          .example-container {
            width: 800px;
            @include make-container();
          }

          .example-row {
            @include make-row();
          }

          .example-content-main {
            @include make-col-ready();

            @include media-breakpoint-up(sm) {
              @include make-col(6);
            }
            @include media-breakpoint-up(lg) {
              @include make-col(8);
            }
          }

          .example-content-secondary {
            @include make-col-ready();

            @include media-breakpoint-up(sm) {
              @include make-col(6);
            }
            @include media-breakpoint-up(lg) {
              @include make-col(4);
            }
          }
        
        
    

Customizing the grid

Using our built-in grid Sass variables and maps, it’s possible to completely customize the predefined grid classes. Change the number of tiers, the media query dimensions, and the container widths—then recompile.

Columns and gutters

The number of grid columns and their horizontal padding (aka, gutters) can be modified via Sass variables. $grid-columns is used to generate the widths (in percent) of each individual column while $grid-gutter-widths allows breakpoint-specific widths that are divided evenly across padding-left and padding-right for the column gutters.

        
            
            $grid-columns: 12 !default;
            $grid-gutter-width: 30px !default;
        
        
    

Grid tiers

Moving beyond the columns themselves, you may also customize the number of grid tiers. If you wanted just three grid tiers, you’d update the $grid-breakpoints and $container-max-widths to something like this:

        
            
              $grid-breakpoints: (
                xs: 0,
                sm: 480px,
                md: 768px,
                lg: 1024px
              );
  
              $container-max-widths: (
                sm: 420px,
                md: 720px,
                lg: 960px
              );
          
        
    

When making any changes to the Sass variables or maps, you’ll need to save your changes and recompile. Doing so will output a brand new set of predefined grid classes for column widths, offsets, and ordering. Responsive visibility utilities will also be updated to use the custom breakpoints. Make sure to set grid values in px (not rem, em, or %).

React Bootstrap Grid system

React Grid system - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Use the powerful responsive flexbox grid to build layouts of all shapes and sizes thanks to a twelve column system, five default responsive tiers, and dozens of predefined classes.


How it works

MDBReact grid system uses a series of components: Rows, Containers and Columns to layout and align content. It’s built with flexbox and is fully responsive. Below is an example and an in-depth look at how the grid comes together.

New to or unfamiliar with flexbox? Read our CSS flexbox guide.

One of three columns
One of three columns
One of three columns
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

The above example creates three equal-width columns on small, medium, large, and extra large devices using our predefined grid classes. Those columns are centered in the page with the parent Containercomponent.

Breaking it down, here’s how it works:

  • Containers provide a means to center your site’s contents. Use <MDBContainer> component for fixed width or <MDBContainer fluid > for width: 100% across all viewport and device sizes.
  • Rows are wrappers for columns. Each MDBCol has horizontal padding (called a gutter) for controlling the space between them. This padding is then counteracted on the rows with negative margins. This way, all the content in your columns is visually aligned down the left side.
  • In a grid layout, content must be placed within MDBCol and only MDBCol may be immediate children of MDBRow.
  • Thanks to flexbox, Columns without a specified width will automatically layout as equal width Columns. For example, four instances of will each automatically be 25% wide from the small breakpoint and up. See the auto-layout columns section for more examples.
  • Column props indicate the number of columns you’d like to use out of the possible 12 per row. So, if you want three equal-width columns, you can use .
  • MDBCol widths are set in percentages, so they’re always fluid and sized relative to their parent element.
  • MDBCol have horizontal padding to create the gutters between individual columns, however, you can remove the margin from MDBRow and padding from MDBCol with .no-gutters className on the MDBRow.
  • To make the grid responsive, there are five grid breakpoints, one for each responsive breakpoint: all breakpoints (extra small), small, medium, large, and extra large.
  • Grid breakpoints are based on minimum width media queries, meaning they apply to that one breakpoint and all those above it (e.g., applies to small, medium, large, and extra large devices, but not the first xs breakpoint).
  • You can use predefined grid classes (like ).

Be aware of the limitations and bugs around flexbox, like the inability to use some HTML elements as flex containers.


Grid options

While Bootstrap uses ems or rems for defining most sizes, pxs are used for grid breakpoints and container widths. This is because the viewport width is in pixels and does not change with the font size.

See how aspects of the Bootstrap grid system work across multiple devices with a handy table.

Extra small
<576px
Small
≥576px
Medium
≥768px
Large
≥992px
Extra large
≥1200px
Grid behavior Horizontal at all times Collapsed to start, horizontal above breakpoints
Container width None (auto) 540px 720px 960px 1140px
prop xs sm md lg xl
# of columns 12
Gutter width 30px (15px on each side of a column)
Nestable Yes
Column ordering Yes

Auto-layout columns

Equal-width

For example, here are two grid layouts that apply to every device and viewport, from xs to xl. Add any number of and every column will be the same width.

1 of 2
1 of 2
1 of 3
1 of 3
1 of 3
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
                <MDBContainer>
                  <MDBRow>
                    <MDBCol>1 of 2</MDBCol>
                    <MDBCol>2 of 2</MDBCol>
                  </MDBRow>
                  <MDBRow>
                    <MDBCol>1 of 3</MDBCol>
                    <MDBCol>2 of 3</MDBCol>
                    <MDBCol>3 of 3</MDBCol>
                  </MDBRow>
                </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Equal-width <MDBCol>can be broken into multiple lines.

Column
Column
Column
Column
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol>Column</MDBCol>
                  <MDBCol>Column</MDBCol>
                  <div className="w-100" />
                  <MDBCol>Column</MDBCol>
                  <MDBCol>Column</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Setting one column width

You can set the width of one <MDBCol> and have the sibling <MDBCol> components automatically resize around it.

1 of 3
2 of 3 (wider)
3 of 3
1 of 3
2 of 3 (wider)
3 of 3
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol>1 of 3</MDBCol>
                  <MDBCol size="6">2 of 3 (wider)</MDBCol>
                  <MDBCol>3 of 3</MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol>1 of 3</MDBCol>
                  <MDBCol size="5">2 of 3 (wider)</MDBCol>
                  <MDBCol>3 of 3</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Equal-width multi-row

Create equal-width <MDBCol> that span multiple rows by inserting a

where you want the columns to break to a new line. Make the breaks responsive by mixing the .w-100 with some responsive display utilities.

col
col
col
col
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol>col</MDBCol>
                  <MDBCol>col</MDBCol>
                  <div className="w-100" />
                  <MDBCol>col</MDBCol>
                  <MDBCol>col</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Responsive classes

MDBReact grid includes five tiers of props for building complex responsive layouts. Customize the size of your <MDBCol> on extra small, small, medium, large, or extra large devices however you see fit.

All breakpoints

For grids that are the same from the smallest of devices to the largest, use the size prop. Specify a value when you need a particularly sized column; otherwise, feel free ommit it.

col
col
col
col
col-8
col-4
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol>col</MDBCol>
                  <MDBCol>col</MDBCol>
                  <MDBCol>col</MDBCol>
                  <MDBCol>col</MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol size="8">col-8</MDBCol>
                  <MDBCol size="4">col-4</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Stacked to horizontal

Using a single set of sm classes, you can create a basic grid system that starts out stacked before becoming horizontal on desktop (medium) devices.

col-sm-8
col-sm-4
col-sm
col-sm
col-sm
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol sm="8">col-sm-8</MDBCol>
                  <MDBCol sm="4">col-sm-4</MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol size="sm">col-sm</MDBCol>
                  <MDBCol size="sm">col-sm</MDBCol>
                  <MDBCol size="sm">col-sm</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Mix and match

Don’t want your <MDBCol> to simply stack in some grid tiers? Use a combination of different props for each tier as needed. See the example below for a better idea of how it all works.

.col .col-md-8
.col-6 .col-md-4
.col-6 .col-md-4
.col-6 .col-md-4
.col-6 .col-md-4
.col-6
.col-6
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol md="8">
                    .col .col-md-8
                  </MDBCol>
                  <MDBCol size="6" md="4">
                    .col-6 .col-md-4
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol size="6" md="4">
                    .col-6 .col-md-4
                  </MDBCol>
                  <MDBCol size="6" md="4">
                    .col-6 .col-md-4
                  </MDBCol>
                  <MDBCol size="6" md="4">
                    .col-6 .col-md-4
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol size="6">
                    .col-6
                  </MDBCol>
                  <MDBCol size="6">
                    .col-6
                  </MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Alignment

Use MDBReact alignment utilities to vertically and horizontally align columns.

Vertical alignment

For grids that are the same from the smallest of devices to the largest, use the .col and .col-* classes. Specify a numbered class when you need a particularly sized column; otherwise, feel free to stick to .col.

Align items start

One of three columns
One of three columns
One of three columns

Align items center

One of three columns
One of three columns
One of three columns

Align items end

One of three columns
One of three columns
One of three columns
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow top>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                </MDBRow>
                <MDBRow middle>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                </MDBRow>
                <MDBRow bottom>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                  <MDBCol>One of three columns</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Algin self

One of three columns
One of three columns
One of three columns
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol top>One of three columns</MDBCol>
                  <MDBCol middle>One of three columns</MDBCol>
                  <MDBCol bottom>One of three columns</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Horizontal alignment

One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
One of two columns
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow start>
                  <MDBCol size="4">One of two columns</MDBCol>
                  <MDBCol size="4">One of two columns</MDBCol>
                </MDBRow>
                <MDBRow center>
                  <MDBCol size="4">One of two columns</MDBCol>
                  <MDBCol size="4">One of two columns</MDBCol>
                </MDBRow>
                <MDBRow end>
                  <MDBCol size="4">One of two columns</MDBCol>
                  <MDBCol size="4">One of two columns</MDBCol>
                </MDBRow>
                <MDBRow around>
                  <MDBCol size="4">One of two columns</MDBCol>
                  <MDBCol size="4">One of two columns</MDBCol>
                </MDBRow>
                <MDBRow between>
                  <MDBCol size="4">One of two columns</MDBCol>
                  <MDBCol size="4">One of two columns</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

No gutters

The gutters between columns in our predefined grid classes can be removed with .no-gutters. This removes the negative margins from <MDBRow> and the horizontal padding from all immediate children <MDBCol>.

Need an edge-to-edge design? Remove the parent <MDBContainer> or <MDBContainer fluid> component.

Column wrapping

If more than 12 columns are placed within a single row, each group of extra columns will, as one unit, wrap onto a new line.

.col-9
.col-4
Since 9 + 4 = 13 > 12, this 4-column-wide div gets wrapped onto a new line as one contiguous unit.
.col-6
Subsequent columns continue along the new line.
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol size="9">
                    .col-9
                  </MDBCol>
                  <MDBCol size="4">
                    .col-4
                    <br />
                    Since 9 + 4 = 13 > 12, this 4-column-wide div gets wrapped onto a new line as one contiguous unit.
                  </MDBCol>
                  <MDBCol size="6">
                    .col-6
                    <br />
                    Subsequent columns continue along the new line.
                  </MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Column breaks

Breaking columns to a new line in flexbox requires a small hack: add an element with width: 100% wherever you want to wrap your columns to a new line. Normally this is accomplished with multiple <MDBRow>s, but not every implementation method can account for this.

.col-6 .col-sm-4
.col-6 .col-sm-4
.col-6 .col-sm-4
.col-6 .col-sm-4
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol size="6" sm="4">
                    .col-6 .col-sm-4
                  </MDBCol>
                  <MDBCol size="6" sm="4">
                    .col-6 .col-sm-4
                  </MDBCol>
                  <div className="w-100"></div>
                  <MDBCol size="6" sm="4">
                    .col-6 .col-sm-4
                  </MDBCol>
                  <MDBCol size="6" sm="4">
                    .col-6 .col-sm-4
                  </MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Reordering

Order classes

Use .order- classes for controlling the visual order of your content. These classes are responsive, so you can set the order by breakpoint (e.g., .order-1.order-md-2). Includes support for 1 through 12 across all five grid tiers.

First, but unordered
Second, but last
Third, but second
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol>First, but unordered</MDBCol>
                  <MDBCol className="order-12">Second, but last</MDBCol>
                  <MDBCol className="order-1">Third, but second</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

There are also responsive .order-first and .order-last classes that change the order of an element by applying order: -1 and order: 13 ( order: $columns + 1), respectively. These classes can also be intermixed with the numbered .order-* classes as needed.

First, but last
Second, but unordered
Third, but first
        
            
            import React from "react";
            import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

            const GridExamplesPage = () => {
              return (
                <MDBContainer>
                  <MDBRow>
                    <MDBCol>First, but unordered</MDBCol>
                    <MDBCol> Second, but unordered</MDBCol>
                    <MDBCol className="order-first">Third, but first</MDBCol>
                  </MDBRow>
                </MDBContainer>
              );
            }

            export default GridExamplesPage;
        
        
    

Offsetting columns

You can offset <MDBCol> in two ways: our responsive .offset- grid classes and our margin utilities. Grid classes are sized to match columns while margins are more useful for quick layouts where the width of the offset is variable.

Offset classes

Move columns to the right using .offset-md-* classes. These classes increase the left margin of a column by * columns. For example, .offset-md-4 moves .col-md-4 over four columns.

.col-md-4
.col-md-4 .offset-md-4
.col-md-3 .offset-md-3
.col-md-3 .offset-md-3
.col-md-6 .offset-md-3
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol md="4">.col-md-4</MDBCol>
                  <MDBCol md="4" className="offset-md-4">
                    .col-md-4 .offset-md-4
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol md="3" className="offset-md-3">
                    .col-md-3 .offset-md-3
                  </MDBCol>
                  <MDBCol md="3" className="offset-md-3">
                    .col-md-3 .offset-md-3
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol md="6" className="offset-md-3">.col-md-6 .offset-md-3</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

In addition to column clearing at responsive breakpoints, you may need to reset offsets. See this in action:

.col-sm-5 .col-md-6
.col-sm-5 .offset-sm-2 .col-md-6 .offset-md-0
.col .col-sm-6 .col-md-5 .col-lg-6
.col-sm-6 .col-md-5 .offset-md-2 .col-lg-6 .offset-lg-0
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol sm="5" md="6">
                    .col-sm-5 .col-md-6
                  </MDBCol>
                  <MDBCol sm="5" md="6" className="offset-sm-2 offset-md-0">
                    .col-sm-5 .offset-sm-2 .col-md-6 .offset-md-0
                  </MDBCol>
                </MDBRow>

                <MDBRow>
                  <MDBCol sm="6" md="5" lg="6">
                    .col-sm-6 .col-md-5 .col-lg-6
                  </MDBCol>
                  <MDBCol sm="6" md="5" lg="6" className="offset-md-2 offset-lg-0">
                    .col-sm-6 .col-md-5 .offset-md-2 .col-lg-6 .offset-lg-0
                  </MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Margin utilities

You can use margin utilities like .mr-auto to force sibling <MDBCol> away from one another.

.col-md-4
.col-md-4 .ml-auto
.col-md-3 .ml-md-auto
.col-md-3 .ml-md-auto
.col-auto .mr-auto
.col-auto
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol md="4">.col-md-4</MDBCol>
                  <MDBCol md="4" className="ml-auto">
                    .col-md-4 .ml-auto
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol md="3" className="ml-md-auto">
                    .col-md-3 .ml-md-auto
                  </MDBCol>
                  <MDBCol md="3" className="ml-md-auto">
                    .col-md-3 .ml-md-auto
                  </MDBCol>
                </MDBRow>
                <MDBRow>
                  <MDBCol size="auto" className="mr-auto">
                    .col-auto .mr-auto
                  </MDBCol>
                  <MDBCol size="auto">.col-auto</MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

Nesting

To nest your content with the default grid, add a new <MDBRow> and set of <MDBCol> columns within an existing <MDBCol> column. Nested rows should include a set of columns that add up to 12 or fewer (it is not required that you use all 12 available columns).

Level 1: .col-sm-9
Level 2: .col-8 .col-sm-6
Level 2: .col-4 .col-sm-6
        
            
          import React from "react";
          import { MDBContainer, MDBRow, MDBCol } from "mdbreact";

          const GridExamplesPage = () => {
            return (
              <MDBContainer>
                <MDBRow>
                  <MDBCol sm="9">
                    Level 1: .col-sm-9
                    <MDBRow>
                      <MDBCol size="8" sm="6">Level 2: .col-8 .col-sm-6</MDBCol>
                      <MDBCol size="4" sm="6">Level 2: .col-4 .col-sm-6</MDBCol>
                    </MDBRow>
                  </MDBCol>
                </MDBRow>
              </MDBContainer>
            );
          }

          export default GridExamplesPage;
        
        
    

React Grid System - API

In this section you will find advanced information about React Gid System. You will find out which modules are required, what are the possibilities of configuring, and what events and methods you can use in working with it.


Grid system import statement

In order to use Grid system components make sure you have imported proper modules first.

        
            
          import { MDBContainer, MDBRow, MDBCol } from 'mdbreact';
        
        
    

API Reference: MDBContainer Properties

The table below shows the configuration options of the MDBContainer component.

Name Type Default Description Example
className String Adds custom classes <MDBContainer className="myClass" ... />
fluid Boolean Use for a full width container, spanning the entire width of your viewport. <MDBContainer fluid ... />

API Reference: MDBRow Properties

The table below shows the configuration options of the MDBRow component.

Name Type Default Description Example
around Boolean Changes alignment of items within MDBRow component. It distributes space around direct childrens <MDBRow around ... />
between Boolean Changes alignment of items within MDBRow component. It distributes space between direct childrens <MDBRow between ... />
bottom Boolean Changes alignment of MDBRow whitin a container. MDBRow is placed at the end <MDBRow bottom ... />
center Boolean Changes alignment of items within MDBRow component. It puts direct childrens around the center <MDBRow center ... />
className String Adds custom classes <MDBRow className="customClass" ... />
end Boolean Changes alignment of items within MDBRow component. It puts direct childrens at the end <MDBRow end ... />
middle Boolean Changes alignment of MDBRow whitin a container. MDBRow is placed around the center <MDBRow middle ... />
start Boolean Changes alignment of items within MDBRow component. It puts direct childrens at the start <MDBRow start ... />
tag String div <MDBRow tag="div" ... />
top Boolean Changes alignment of MDBRow whitin a container. MDBRow is placed at the start <MDBRow top ... />

API Reference: MDBCol Properties

The table below shows the configuration options of the MDBCol component.

Name Type Default Description Example
bottom Boolean Changes alignment of MDBCol whitin a row. MDBCol is placed at the end <MDBCol bottom ... />
className String Adds custom classes <MDBCol className="myClass" ... />
lg String Gives n equal-width columns starting at larger desctops. <MDBCol lg="4" ... />
md String Gives n equal-width columns starting at medium devices and scaling to large desktops. <MDBCol md="4" ... />
size String Indicates the number of columns you’d like to use out of the possible 12 per row <MDBCol size="4" ... />
sm String Gives n equal-width columns starting at small devices and scaling to large desktops. <MDBCol sm="4" ... />
middle Boolean Changes alignment of MDBCol whitin a row. MDBCol is placed around the center <MDBCol middle ... />
top Boolean Changes alignment of MDBCol whitin a row. MDBCol is placed at the start <MDBCol top ... />
xl String Gives n equal-width columns starting at extra larg devices. <MDBCol xl="4" ... />
xs String Gives n equal-width columns starting at extra small devices and scaling to large desktops. <MDBCol xs="4" ... />